#! /usr/bin/perl
print "Content-type: text/html\n\n";

if($ENV{"REQUEST_METHOD"} eq "GET") {
  $datastring= $ENV{"QUERY_STRING"};		
}
elsif($ENV{"REQUEST_METHOD"} eq "POST") {
  read(STDIN, $datastring, $ENV{"CONTENT_LENGTH"});
}
else {
  print "Offline execution detected\n";
  print "Please enter some data.\n";
  $datastring = <>;
  chomp $datastring;
  print "== data accepted == HTML output follows ==\n\n";
}

###decode######################################################
$datastring =~s/%0D%0A/\n/g;                    		#step to deal with line
														#breaks in text areas
@nameValuePairs = split(/&/, $datastring);				#step 1
foreach $pair (@nameValuePairs) {
  ($name, $value) = split(/=/, $pair);					#step 2
  
  $name =~tr/+/ /;                                 		#step 3
  $name =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg; 		#step 3
  $value =~tr/+/ /;                                		#step 3
  $value =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg;		#step 3
  
  if(exists $formHash{$name}) {							#improved step 4, now handles
    $formHash{$name} = $formHash{$name}.";".$value;		#multiple select menus
  } 														
  else {
    $formHash{$name} = $value;
  }   	
}
###done decoding###############################################

### Some global variables #####################################
$storyDataDir = "newsStories/";   # where the stories are
### end of global variables ###################################

### app logic #################################################
if($formHash{"request"} eq "full_story"){
	&full_story;
}
else{
	&main_page;
}
### end app logic #############################################


###############################################################
sub main_page {
  print <<TOP;
 <html><head><title>Main Story Page</title></head><body>
   <b>Check out the latest news.</b>
   <table border="2">
TOP

	opendir(DIRECTORYHANDLE, "$storyDataDir");
	@storyFiles = readdir(DIRECTORYHANDLE);
	closedir(DIRECTORYHANDLE);

	@storyFiles = grep (/.news/ , @storyFiles);
	
  	foreach $file (@storyFiles) {
    	if(open(STORY, "$storyDataDir$file")) {
      		my @wholeStory = <STORY>;
      		close(STORY);
      		my $story = join("", @wholeStory); #put whole story into one string
      		
      		my @paragraphs = ($story =~ /((.|\n)+?\n\s*\n)/g);  ### ouch, that hurts
      		
      		print <<TABLEROW;
      		<tr><td>
      		$paragraphs[0]$paragraphs[2]
      		 ...<a href="$ENV{'SCRIPT_NAME'}?request=full_story&story=$file">Full story</a>
      		</td></tr>
TABLEROW
    	}
 	}
  	print <<BOTTOM;
   	</table>
  	</body></html>
BOTTOM
}

###############################################################
sub full_story {
  my (@storyArray, $storyString);
  my $file = $formHash{"story"};
  
  open(STORY, "$storyDataDir$file") or &errorPage("Sorry, story not available.");
  @storyArray = <STORY>;
  close(STORY);
  
  $storyString = join("", @storyArray); 
    
  $storyString =~ s/\n\s*\n/<br\/><br\/>/g;  #to preserve paragraph structure
  
  print <<PAGE;
 <html><head><title>Full Story</title></head><body>
   <h2>The full story:</h2>
    $storyString
    <hr/>
    <a href="$ENV{'SCRIPT_NAME'}">Back to main page</a>
  </body></html>
PAGE
}
